/**
  *  \file client/dlg-subject.h
  *  \brief Message Subject Overview
  *
  *  (c) 2001-2024 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_SUBJECT_H
#define PCC_V2_CLIENT_DLG_SUBJECT_H

#include <vector>
#include "ui/listbox.h"
#include "game/msg.h"

class WSubjectList : public UIListbox {
    GMessagebox& mbox;
    GMessageFilter& filter;

    struct Group {
        int first_msg;
        int count;

        Group(int first_msg, int count)
            : first_msg(first_msg), count(count)
            { }
    };
    std::vector<Group> groups;

    void createGroupList();

 public:
    WSubjectList(int id, GMessagebox& mbox, GMessageFilter& filter);
    ~WSubjectList();

    void drawPart(GfxCanvas& can, int from, int to);
    int doStandardDialog();

    void toggleFilterSelectedMessage();
    bool isSelectedMessageFiltered() const;
    int  getSelectedMessage() const;
    void selectMessage(int n);

    void regenerate();
};

#endif
