/**
  *  \file client/dlg-warp.h
  *
  *  (c) 2001-2024 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_WARP_H
#define PCC_V2_CLIENT_DLG_WARP_H

#include "ui/ui.h"
#include "ui/window.h"
#include "ui/widgets/numbersel.h"
#include "game/fleetfc.h"

class GShip;

class WShipSpeedSelector : public UINumberSelector {
    GShip&   ship;
    int      orig_speed;
    GFleetFCodeChanger orig_fcs;

    void shipUpdated();
    void widgetUpdated();

    SignalConnection turn_conn;
 public:
    WShipSpeedSelector(GShip& ship);
    ~WShipSpeedSelector();

    bool handleEvent(const UIEvent& e, bool second_pass);
    void drawContent(GfxCanvas& can);
    void getLayoutInfo(LayoutInfo& li);

    void doStandardDialog();

    void revert();
};

#endif
