/**
  *  \file client/widgets/funcinfo.h
  *  \brief Hull Function Information Widget
  *
  *  (c) 2001-2024 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_FUNCINFO_H
#define PCC_V2_CLIENT_WIDGETS_FUNCINFO_H

#include "game/hullfunc.h"
#include "game/ship.h"
#include "ui/richdocument.h"
#include "ui/ui.h"

/** Hull function information widget. Displays information about a
    hull function, including assignment information and
    description. */
class WHullFunctionInfo : public UIRichDocument {
 public:
    WHullFunctionInfo(int owner, int damage, const GShipExperienceInfo& expInfo);
    ~WHullFunctionInfo();

    void setFunction(const GHullFunction* hf);

 private:
    int owner, damage;
    GShipExperienceInfo expInfo;
};

#endif
