/**
  *  \file client/widgets/propertylist.h
  *  \brief WPropertyList widget
  *
  *  (c) 2001-2024 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_PROPERTYLIST_H
#define PCC_V2_CLIENT_WIDGETS_PROPERTYLIST_H

#include "ui/listbox.h"

class IntVariableNames;
class IntDataSegment;

/** Displays a list of user-defined properties and their values. */
class WPropertyList : public UIListbox {
 public:
    WPropertyList(int id,
                  const IntVariableNames& names,
                  const IntDataSegment& data);
    ~WPropertyList();

    void drawPart(GfxCanvas& can, int from, int to);

 private:
    const IntVariableNames& names;
    const IntDataSegment& data;
};

#endif
