/**
  *  \file game/storage.h
  *
  *  (c) 2001-2024 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_STORAGE_H
#define PCC_V2_GAME_STORAGE_H

#include "cpluslib/smartptr.h"

class GGameTurn;

class GGameDataStorage {
 public:
    virtual ~GGameDataStorage();
    virtual void load(GGameTurn& trn) = 0;
    virtual void save(GGameTurn& trn) = 0;

    static Ptr<GGameDataStorage> instance;
};

class GGameDirectoryStorage : public GGameDataStorage {
    int player;
 public:
    GGameDirectoryStorage(int player);
    void load(GGameTurn& trn);
    void save(GGameTurn& trn);
};

class GGameResultStorage : public GGameDataStorage {
    int player;
    bool have_trn;
 public:
    GGameResultStorage(int player, bool have_trn);
    void load(GGameTurn& trn);
    void save(GGameTurn& trn);
};

#endif
